//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "RichView"
#pragma link "RVScroll"
#pragma link "RVStyle"
#pragma resource "*.dfm"
int btnNo = 0;
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnAddTextClick(TObject *Sender)
{
	RichView1->AddNL("Hello",0, 0);
	RichView1->FormatTail();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnControlClick(TObject *Sender)
{
	ShowMessage("Thank you for pressing " + ((TButton*)Sender)->Name);
}
void __fastcall TForm1::btnAddButtonClick(TObject *Sender)
{
	TButton* btn = new TButton((TComponent*) NULL);
	btn->OnClick = OnControlClick;
	btn->Name = "Btn" + UnicodeString(btnNo++);
	btn->Caption = btn->Name;
	// Option 1: from new line
	RichView1->AddControl("", btn, 0, rvvaAbsMiddle);
	RichView1->FormatTail();
	/*
	// Option 2: to the end of last line
	RichView1->AddControl("", btn, -1, rvvaAbsMiddle);
	RichView1->Format();
	*/
}

//---------------------------------------------------------------------------

void __fastcall TForm1::AddParagraphClick(TObject *Sender)
{
	UnicodeString txt = "Line #1\rLine #2", txt1, txt2;
	int where = txt.Pos("\r");
	txt1 = txt.SubString(0, where-1);
	txt2 = txt.SubString(where+1, 9999);
	RichView1->AddNL(txt1, 0, 0);
	RichView1->AddNL(txt2, 2, 0);
	RichView1->FormatTail();
}
//---------------------------------------------------------------------------

int GetTabbedParaNo(TRVStyle* rvs)
{
	TParaInfo* ParaStyle = new TParaInfo(NULL);
	ParaStyle ->Assign(rvs->ParaStyles->Items[0]);
	TRVTabInfo* Tab = ParaStyle->Tabs->Add();
	Tab->Position = rvs->RVUnitsToUnits(0.25, rvuInches);
	Tab = ParaStyle->Tabs->Add();
	Tab->Position = rvs->RVUnitsToUnits(0.4, rvuInches);
	int r = rvs->FindParaStyle(ParaStyle);
	delete ParaStyle;
	return r;
}

void __fastcall TForm1::AddTabsClick(TObject *Sender)
{
	UnicodeString txt = "aa\tb\tc\r\nd\te\tf";
	int ParaNo = GetTabbedParaNo(RVStyle1);
	RichView1->AddTextNL(txt, 0, ParaNo, ParaNo);
    RichView1->FormatTail();
}
//---------------------------------------------------------------------------

